﻿package 
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.NetStatusEvent;
	
	import flash.net.NetConnection;
	import flash.net.ObjectEncoding;
	import flash.net.Responder;
	
	import com.adobe.serialization.json.*;
	
	public class FlashRemotingCaller extends Sprite
	{
		public function FlashRemotingCaller()
		{
			this.TestBtn.addEventListener(MouseEvent.CLICK, this.testBtnClick);
			this.ClearBtn.addEventListener(MouseEvent.CLICK, this.clearBtnClick);
			this.Loading.visible = false;
		}
		
		private function testBtnClick(evt:MouseEvent):void{
			var json:String = this.Json.text;
			var service:NetConnection = new NetConnection();
			service.objectEncoding = ObjectEncoding.AMF0;
			service.addEventListener(NetStatusEvent.NET_STATUS, this.connectionStatus);
			try{
				service.connect(this.Url.text);
			}catch(e:Error){
				this.Errors.text = e.toString();
				this.Loading.visible = false;
				return;
			}

			var responder:Responder = new Responder(this.onResultSuccess, this.onResultError);
			var array:Array = [this.Service.text+"."+this.Method.text, responder];
			
			var paramsArray:Array = null;
			try{
				paramsArray = JSON.decode(this.Json.text) as Array;
			}catch(e:Error){
				this.Errors.text = "There is error in your JSON "+
				"(the top most element in your JSON must be array, as [ ])\n"+e;
				this.Loading.visible = false;
				return;
			}
			for(var i:int = 0; i < paramsArray.length; i++){
				array.push(paramsArray[i]);
			}
			
			this.Result.text = "";
			this.Errors.text = "";
			
			try{
        		service.call.apply(service, array);
				this.Loading.visible = true;
			}catch(e:Error){
				this.Errors.text = e.toString();
				this.Loading.visible = false;
			}
			
		}
		private function connectionStatus(evt:Object):void{
			if(evt.info.level == "error"){
				this.Errors.text = t.obj(evt.info, "Connection Error");
				this.Loading.visible = false;
			}
		}
		
		private function clearBtnClick(evt:MouseEvent):void{
			this.Result.text = "";
			this.Errors.text = "";
		}
		
		private function onResultSuccess(result:Object):void{
			this.Result.text = t.obj(result);
			this.Loading.visible = false;
		}
		private function onResultError(result:Object):void{
			this.Errors.text = t.obj(result);
			this.Loading.visible = false;
		}
	}
}
